
package BRPG_accessories
{
	function GameConnection::applyBodyParts(%client)
	{
		Parent::applyBodyParts(%client);
		if(RPG_MinigameCheck(%client))
			accessoryCheck(%client);
	}
};activatepackage(BRPG_accessories);

function accessoryCheck(%client)
{
	%player = %client.player;

	%player.hidenode("armor");
	%player.hidenode("bucket");
	%player.hidenode("cape");
	%player.hidenode("pack");
	%player.hidenode("quiver");
	%player.hidenode("tank");
	%player.hidenode("shoulderpads");
	
	switch$(%client.RPG["armor"])
	{
		case "Leather Armor":
			%client.RPG["def"] = 4;
			%player.unhidenode("armor");
			%player.unhidenode("shoulderpads");
			%player.setNodeColor("armor", "0.392457 0.192157 0 1");
			%player.setNodeColor("shoulderpads", "0.392457 0.192157 0 1");
		case "Iron Armor":
			%client.RPG["def"] = 12;
			%player.unhidenode("armor");
			%player.unhidenode("shoulderpads");
			%player.setNodeColor("armor", "0.498039 0.498039 0.498039 1");
			%player.setNodeColor("shoulderpads", "0.498039 0.498039 0.498039 1");
		default:
			%client.RPG["def"] = 0;
	}
	switch$(%client.RPG["pack"])
	{
		case "Magic Cape":
			%player.unhidenode("cape");
			%player.setNodeColor("cape", "0.392457 0.192157 0 1");
		case "Backpack":
			%player.unhidenode("pack");
			%player.setNodeColor("pack", "0.392457 0.192157 0 1");
		case "Quiver":
			%player.unhidenode("quiver");
			%player.setNodeColor("quiver", "0.392457 0.192157 0 1");
		default:
	}
	updateArrows(%client);
	%client.updateDataBlock();
}

function serverCmdRemoveArmor(%client)
{
	if(!RPG_Minigamecheck(%client, 1))
		return false;
	
	schedule(100, 0, serverCmdUnUseTool,%client);
	if(%client.RPG["armor"] $= "")
		return true;
	
	if(!%client.player.giveItem($uiNameTable_Items[%client.RPG["armor"]]))
	{
		commandToClient(%client, 'centerPrint', "Your inventory is full!", 2);
		return false;
	}
	%client.RPG["armor"] = "";
	accessoryCheck(%client);
	return true;
}

function serverCmdRemovePack(%client)
{
	if(!RPG_Minigamecheck(%client, 1))
		return false;
	
	schedule(100, 0, serverCmdUnUseTool,%client);
	if(%client.RPG["pack"] $= "")
		return true;
	
	%pack = %client.RPG["pack"];
	
	
	if(%client.RPG["pack"] $= "Backpack")
	{
		%player = %client.player;
		%toolCount = 1;
		for(%i = 0; %i < %player.getDatablock().maxTools; %i++)
		{
			%tool = %player.tool[%i];
			if(%tool != 0)
			{
				%tools[%toolCount] = %tool;
				%toolCount++;
			}
		}
		if(%toolCount > PlayerRPG.maxTools)
		{
			commandToClient(%client, 'centerPrint', "You need to drop some of your items!", 2);
			return false;
		}
		for(%i = PlayerRPG.maxTools; %i < %player.getDatablock().maxTools; %i++)
		{
			if(%player.tool[%i] != 0)
			{
				for(%j = 0; %j < PlayerRPG.maxTools; %j++)
				{
					%player.tool[%j] = %tools[%j];
					messageClient(%client,'MsgItemPickup','',%j,%tools[%j]);
				}
				for(%j = PlayerRPG.maxTools; %j < %player.getDatablock().maxTools; %j++)
				{
					%player.tool[%j] = 0;
					messageClient(%client,'MsgItemPickup','',%j,0);
				}
				break;
			}
		}
	}
	
	if(!%client.player.giveItem($uiNameTable_Items[%client.RPG["pack"]],%client))
	{
		commandToClient(%client, 'centerPrint', "Your inventory is full!", 2);
		return false;
	}
	
	%client.RPG["pack"] = "";
	accessoryCheck(%client);
	return true;
}