
// Borrowed from Brick_Checkpoint
function getCheckPointBrick(%pos)
{
  //attempt to recover checkpoint brick from checkpoint position
  %box = "0.1 0.1 0.1";
  %mask = $TypeMasks::FxBrickAlwaysObjectType;
  InitContainerBoxSearch(%pos, %box, %mask);

  while (%checkBrick = containerSearchNext())
  {	
	 if(%checkBrick.getDataBlock().getName() !$= "brickCheckpointData")
		continue;

	 return %checkBrick;
  }
}

function writeSaveData(%client)
{
	$RPG_fileObject.writeLine("Name" TAB %client.RPG["name"]);
	$RPG_fileObject.writeLine("Class" TAB %client.RPG["class"]);
	$RPG_fileObject.writeLine("Level" TAB %client.RPG["level"]);
	$RPG_fileObject.writeLine("Gold" TAB %client.RPG["gold"]);
	$RPG_fileObject.writeLine("Exp" TAB %client.RPG["exp"]);
	$RPG_fileObject.writeLine("SP" TAB %client.RPG["sp"]);
	$RPG_fileObject.writeLine("HP" TAB %client.RPG["hp"] TAB "/" TAB %client.RPG["maxhp"]);
	$RPG_fileObject.writeLine("MP" TAB %client.RPG["mp"] TAB "/" TAB %client.RPG["maxmp"]);
	$RPG_fileObject.writeLine("Str" TAB %client.RPG["str"]);
	$RPG_fileObject.writeLine("Dex" TAB %client.RPG["dex"]);
	$RPG_fileObject.writeLine("Con" TAB %client.RPG["con"]);
	$RPG_fileObject.writeLine("Int" TAB %client.RPG["int"]);
	$RPG_fileObject.writeLine("Arrows" TAB %client.RPG["arrows"] TAB "/" TAB %client.RPG["maxarrows"]);
	$RPG_fileObject.writeLine("Ore" TAB %client.RPG["ore"]);
	$RPG_fileObject.writeLine("Armor" TAB %client.RPG["armor"]);
	$RPG_fileObject.writeLine("Pack" TAB %client.RPG["pack"]);
	%line = "Quests1";
	for(%i = 1; %i <= 3; %i++)
	{
		if(%client.RPG["quest_1-" @ %i])
			%line = %line TAB %client.RPG["quest_1-" @ %i];
		else
			%line = %line TAB 0;
	}
	if(%line $= "Quests1")
		%line = "Quests1" TAB "";
	$RPG_fileObject.writeLine(%line);
	for(%i = 0; %i < %client.player.dataBlock.maxTools; %i++)
	{
		%client.RPG["item" @ %i] = %client.player.tool[%i].uiName;
		$RPG_fileObject.writeLine("Item" @ %i TAB %client.player.tool[%i].uiName);
	}
	$RPG_fileObject.writeLine("Stock" TAB %client.RPG["durability"]);
	if(%client.RPG["skill_block"])
		%skills = "Block";
	if(%client.RPG["skill_parry"])
		%skills = %skills TAB "Parry";
	if(%client.RPG["skill_sprint"])
		%skills = %skills TAB "Sprint";
	if(%client.RPG["skill_airjump"])
		%skills = %skills TAB "Airjump";
	$RPG_fileObject.writeLine("Skills" TAB %skills);
	if(isObject(%client.checkpointbrick))
	{
		%client.RPG["spawn"] = %client.checkpointbrick.getPosition();
	}
	$RPG_fileObject.writeLine("Spawn" TAB %client.RPG["spawn"]);
}

function readSaveData(%client, %line)
{
	//echo(%line);
	%client.RPG[getField(%line,0)] = getField(%line,1);
	while(!$RPG_fileObject.isEOF())
	{
		%line = $RPG_fileObject.readLine();
		%field0 = getField(%line,0);
		if(%field0 $= "Name")
			break;
		//echo(%line);
		switch$(%field0)
		{
			case "HP":
				%client.RPG["hp"] =getField(%line,1);
				%client.RPG["maxhp"] =getField(%line,3);
			case "MP":
				%client.RPG["mp"] =getField(%line,1);
				%client.RPG["maxmp"] =getField(%line,3);
			case "Arrows":
				%client.RPG["arrows"] =getField(%line,1);
				%client.RPG["maxarrows"] =getField(%line,3);
			case "Skills":
				%count = 1;
				%field = getField(%line, %count);
				while(%field !$= "")
				{
					//echo("count:" SPC %count);
					//echo("field:" SPC %field);
					%client.RPG["skill_" @ %field] = true;
					%count++;
					%field = getField(%line, %count);
				}
			case "Quests1":
				%count = 1;
				%field = getField(%line, %count);
				while(%field !$= "")
				{
					//echo("count:" SPC %count);
					//echo("field:" SPC %field);
					%client.RPG["quest_1-" @ %count] = %field;
					%count++;
					%field = getField(%line, %count);
				}
			case "Spawn":
				if(!%client.RPG_skipCheckpointLoading)
				{
					%client.checkPointBrick = getCheckPointBrick(getField(%line, 1));
					%client.RPG["spawn"] = getField(%line,1);
					%client.RPG_skipCheckpointLoading = false;
				}
			case "Stock":
				%count = 1;
				%field = getField(%line, %count);
				%client.RPG["durability"] = %field;
				%count = 2;
				%field = getField(%line, %count);
				while(%field !$= "")
				{
					%client.RPG["durability"] = %client.RPG["durability"] TAB %field;
					%count++;
					%field = getField(%line, %count);
				}
			default:
				%client.RPG[%field0] = getField(%line,1);
		}			
	}
	//if(%client.RPG["guild"] !$= "")
	//{
	//	%client.RPG["pvp"] = 1;
	//	%client.player.setShapeNameColor(getColorIDTable($GuildData::Color[%client.RPG["guild"]]));
	//}
	//else
	//{
		%client.RPG["pvp"] = 0;
		%client.player.setShapeNameColor("1 1 1 1");
	//}
	//if(%client.RPG["armor"] !$= "")
	//{
	//	accessoryCheck(%client);
	//}
}

function GameConnection::loadTools(%client)
{
	if(!%client.player) return;
	if(!RPG_MinigameCheck(%client)) return;
	if(!%client.RPG["level"]) return;
	
	for(%i = 0; %i < %client.player.dataBlock.maxTools; %i++)
	{
		%item = $uiNameTable_Items[%client.RPG["item" @ %i]];
		if(%item $= "")
			%item = 0;
		%client.player.tool[%i] = %item;
		messageClient(%client,'MsgItemPickup',"",%i,%item,1);
	}
	%client.RPG_WaitingForTools = false;
}

function GameConnection::saveStats(%client)
{
	if(!%client.player) return;
	if(!RPG_MinigameCheck(%client)) return;
	if($uinametable_items["Hammer "] == 0)
	{
		echo("WARNING: uiNameTable not set!");
		return;
	}
	if(!%client.RPG["level"]) return;
	if(%client.RPG_WaitingForTools) return;
	
	
	if(!isObject($RPG_fileObject))
		$RPG_fileObject = new fileObject();
	
	%fileName = %client.bl_ID;
	if(%fileName == 999999 || %fileName $= "") %fileName = "local";
	
	if(!%client.RPG["char"])
		%client.RPG["char"] = 1;
	
	$RPG_fileObject.openForRead("config/server/BasicRPG/save/" @ %fileName @ ".txt");
	%lines = 0;
	//echo("Beginning input"  NL "-----");
	while(!$RPG_fileObject.isEOF())
	{
		%line = $RPG_fileObject.readLine();
		if(%line $= "")
		{
			//echo("Empty line, continuing...");
			continue;
		}
		//echo(%lines @ ":" SPC %line);
		%saveLine[%lines] = %line;
		%lines++;
	}
	//echo("-----" NL "End of input");
	//echo("");

	//echo("Beginning output" NL "-----");
	if(!$RPG_fileObject.openForWrite("config/server/BasicRPG/save/" @ %fileName @ ".txt"))
	{
		//echo("Could not open file for write");
		$RPG_fileObject.close();
		return;
	}
	for(%i = 0; %i < %lines; %i++)
	{
		if(%character == 0 || getField(%saveLine[%i],0) $= "Name")
		{
			%character++;
			$RPG_fileObject.writeLine("");
			//echo("");
			if(%client.RPG["char"] == %character)
			{
				writeSaveData(%client);
				%saved = 1;
				%i++;
				while(getField(%saveLine[%i],0) !$= "Name" && %i < %lines)
				{
					%i++;
				}
				if(%i >= %lines) break;
				%i--;
				continue;
			}
		}
		$RPG_fileObject.writeLine(%saveLine[%i]);
		//echo(%i @ ":" SPC %saveLine[%i]);
	}
	if(%saved != 1)
	{
		$RPG_fileObject.writeLine("");
		writeSaveData(%client);
	}
	//echo("-----" NL "End of output");
	$RPG_fileObject.close();
}

function GameConnection::loadStats(%client)
{
	//if(!%client.player) return;
	if(!RPG_MinigameCheck(%client)) return;
	
	if($uinametable_items["Hammer "] == 0)
	{
		echo("WARNING: uiNameTable not set!");
		return;
	}
	
	setDefaultValues(%client);
	
	if(!isObject($RPG_fileObject))
		$RPG_fileObject = new fileObject();
	
	%fileName = %client.bl_ID;
	if(%fileName == 999999 || %fileName $= "") %fileName = "local";

	if(!%client.RPG["char"])
		%client.RPG["char"] = 1;
		
	$RPG_fileObject.openForRead("config/server/BasicRPG/save/" @ %fileName @ ".txt");
	while(!$RPG_fileObject.isEOF())
	{
		%line = $RPG_fileObject.readLine();
		if(%line $= "")
			continue;
		
		//echo("line");
		if(%character == 0 || getField(%line,0) $= "Name")
		{
			//echo("found character");
			%character++;
			if(%client.RPG["char"] $= %character)
			{
				//echo("correct character");
				//echo(%line);
				readSaveData(%client, %line);
				break;
			}
		}
	}
	$RPG_fileObject.close();

	%client.RPG_WaitingForTools = true;
	%client.schedule(200,loadTools);
	%client.schedule(200,applyDurability);
	
	return %character;
}