
$RPG::ExpTable[1]  = 0;
$RPG::ExpTable[2]  = 100;
$RPG::ExpTable[3]  = 400;
$RPG::ExpTable[4]  = 900;
$RPG::ExpTable[5]  = 1600;
$RPG::ExpTable[6]  = 2500;
$RPG::ExpTable[7]  = 3600;
$RPG::ExpTable[8]  = 4800;
$RPG::ExpTable[9]  = 6400;
$RPG::ExpTable[10] = 8100;
$RPG::ExpTable[11] = 10000;
$RPG::ExpTable[12] = 12100;
$RPG::ExpTable[13] = 14400;
$RPG::ExpTable[14] = 16900;
$RPG::ExpTable[15] = 19600;
$RPG::ExpTable[16] = 22500;
$RPG::ExpTable[17] = 25600;
$RPG::ExpTable[18] = 28900;
$RPG::ExpTable[19] = 32400;
$RPG::ExpTable[20] = 36100;
$RPG::ExpTable[21] = 10000000000000;

function setDefaultValues(%client)
{
	for(%i = 0; %i < %client.player.dataBlock.maxTools; %i++)
	{
		%client.player.tool[%i] = 0;
		%client.RPG["item" @ %i] = "";
	}
	%client.player.setShapeNameColor("1 1 1 1");
	%client.RPG["name"] = %client.name;
	%client.RPG["class"] = "Villager";
	%client.RPG["level"] = 1;
	%client.RPG["gold"] = 0;
	%client.RPG["exp"] = 0;
	%client.RPG["hp"] = 30;
	%client.RPG["mp"] = 20;
	%client.RPG["maxhp"] = 30;
	%client.RPG["maxmp"] = 20;
	%client.RPG["def"] = 0;
	%client.RPG["sp"] = 0;
	%client.RPG["str"] = 1;
	%client.RPG["dex"] = 1;
	%client.RPG["con"] = 1;
	%client.RPG["int"] = 1;
	%client.RPG["arrows"] = 30;
	%client.RPG["maxarrows"] = 30;
	%client.RPG["ore"] = 0;
	%client.RPG["guild"] = "";
	%client.RPG["rank"] = 0;
	%client.RPG["armor"] = "";
	%client.RPG["pack"] = "";
	%client.RPG["spawn"] = "";
	%client.RPG["durability"] = "";
	accessoryCheck(%client);
	for(%i = 1; %i <= 10; %i++)
		%client.RPG["quest_" @ 1 @ "-" @ %i ] = 0;
	for(%i = 1; %i <= 10; %i++)
		%client.RPG["quest_" @ 2 @ "-" @ %i ] = 0;
	for(%i = 1; %i <= 10; %i++)
		%client.RPG["quest_" @ 3 @ "-" @ %i ] = 0;
	for(%i = 1; %i <= 10; %i++)
		%client.RPG["quest_" @ 4 @ "-" @ %i ] = 0;
	for(%i = 1; %i <= 10; %i++)
		%client.RPG["quest_" @ 0 @ "-" @ %i ] = 0;
	%client.RPG["skill_block"] = 0;
	%client.RPG["skill_parry"] = 0;
	%client.RPG["skill_sprint"] = 0;
	%client.RPG["skill_airjump"] = 0;
	%client.RPG["pvp"] = 0;
}

package RPG_painEmote
{
	function player::damage(%this, %obj, %pos, %damage, %damageType)
	{
		%rel = %damage / %this.dataBlock.maxDamage;
		if(%rel > 0 && %rel < 0.25)
			%this.emote(PainLowImage, 1, 1);
		if(%rel >= 0.25 && %rel < 0.40)
			%this.emote(PainMidImage, 1, 1);
		if(%rel >= 0.40)
			%this.emote(PainHighImage, 1, 1);
		if(%rel > 0.10)
			%this.playPain(1);
		Parent::damage(%this, %obj, %pos, %damage, %damageType);
	}
	function Player::emote(%player, %emote, %val, %pain)
	{
		if(%emote !$= "PainLowImage" && %emote !$= "PainMidImage" && %emote !$= "PainHighImage")
			Parent::emote(%player, %emote, %val);
		else
			if(%pain)
				Parent::emote(%player, %emote, %val);
	}
	function Player::playPain(%player, %pain)
	{
		if(%pain)
			Parent::playPain(%player, %pain);
	}
};activatepackage(RPG_painEmote);

package HP_MP_Tweak
{
	function player::damage(%this, %obj, %pos, %damage, %damageType)
	{
		if(%this.getClassName() $= "Player" && !RPG_MinigameCheck(%this.client))
			return Parent::damage(%this, %obj, %pos, %damage, %damageType);
		
		%this.lastAttacker = %obj.sourceObject;
		if(%this.client.RPG["level"])
		{
			%damage = %damage / %this.client.RPG["maxhp"] * %this.dataBlock.maxDamage;
			Parent::damage(%this, %obj, %pos, %damage, %damageType);
			if(%this.getDamageLevel() < %this.dataBlock.maxDamage)
			{
				updateHP(%this.client);
				%this.client.displayHud();
			}
		}
		else
		{
			if($MonsterData::HP[%this.dataBlock.uiName] > 0)
			{
				%maxhp = $MonsterData::HP[%this.dataBlock.uiName];
				%maxDamage = %this.dataBlock.maxDamage;
				%damage = %damage / %maxhp * %maxDamage;
				Parent::damage(%this, %obj, %pos, %damage, %damageType);
				if(%this.getDamageLevel() < %maxDamage)
				{
					%hp = (%maxDamage - %this.getDamageLevel()) * %maxhp / %maxDamage;
					if(%hp - mFloor(%hp) < 0.5) %hp = mFloor(%hp);
					else %hp = mCeil(%hp);
					%dmgLvl = %maxDamage - %hp / %maxHP * %maxDamage;
					%this.setDamageLevel(%dmgLvl);
				}
			}
			else
				Parent::damage(%this, %obj, %pos, %damage, %damageType);
		}
   }
   function Armor::onDisabled(%data,%this,%state)
   {
	if(%this.client.RPG["level"] && RPG_MinigameCheck(%this.client))
	{
      %this.client.RPG["hp"] = 0;
      %this.client.displayHud();
	}
    return Parent::onDisabled(%data,%this,%state);
   }
};activatepackage(HP_MP_Tweak);

package PlayerVersusPlayer
{
	function player::damage(%this, %obj, %pos, %damage, %damageType)
	{
//		if(%obj.client.RPG["level"] $= "" || %this.client.RPG["level"] $= "")
//			return Parent::damage(%this, %obj, %pos, %damage, %damageType);
//		else
//			if(%obj.client.RPG["pvp"] && %this.client.RPG["pvp"])
//				return Parent::damage(%this, %obj, %pos, %damage, %damageType);
//			else
//				if(%obj.client == %this.client)
//					return Parent::damage(%this, %obj, %pos, %damage, %damageType);

		if(%this.getClassName() $= "Player" && !RPG_MinigameCheck(%this.client))
			return Parent::damage(%this, %obj, %pos, %damage, %damageType);
			
		if(%obj.client.RPG["level"] && %this.client.RPG["level"] && %obj.client != %this.client)
		{
			if(!%obj.client.RPG["pvp"] || !%this.client.RPG["pvp"])
				return;
			if(%obj.client.RPG["guild"] $= %this.client.RPG["guild"] && %obj.client.RPG["guild"] !$= "")
				return;
		}
		Parent::damage(%this, %obj, %pos, %damage, %damageType);
	}
};activatepackage(PlayerVersusPlayer);

function updateHP(%client)
{
	if(%client.player != 0)
	{
		%hp = (100 - %client.player.getDamageLevel()) * %client.RPG["maxhp"] / 100;
		if(%hp - mFloor(%hp) < 0.5) %client.RPG["hp"] = mFloor(%hp);
		else %client.RPG["hp"] = mCeil(%hp);
		%dmgLvl = 100 - %client.RPG["hp"] / %client.RPG["maxhp"] * 100;
		//if(%dmgLvl == 100) %client.player.kill();
		//else 
		%client.player.setDamageLevel(%dmgLvl);
	}
}

function updateMP(%client)
{
	if(%client.player != 0)
	{
		%mp = (%client.player.getEnergyLevel()) / 100 * %client.RPG["maxmp"];
		%client.RPG["mp"] = mFloor(%mp);
	}
}

function updateMaxHP(%client)
{
      %client.RPG["maxhp"] = mFloor(2 * %client.RPG["level"] * (%client.RPG["con"] + 9) + 10 * %client.RPG["con"]);
}

function updateMaxMP(%client)
{
      %client.RPG["maxmp"] = mFloor(%client.RPG["level"] * (%client.RPG["int"] + 3) / 2 + 5 * %client.RPG["int"] + 13);
}

function updateArrows(%client)
{
	%client.RPG["maxarrows"] = (%client.RPG["level"] - 1) * 2 + 30;
	if(%client.RPG["pack"] $= "Quiver")
		%client.RPG["maxarrows"] += 30;
	if(%client.RPG["arrows"] > %client.RPG["maxarrows"])
		%client.RPG["arrows"] = %client.RPG["maxarrows"];
}

function GameConnection::updateDataBlock(%client)
{
	%client.player.changeDataBlock(%client.RPG["pack"] $= "Backpack" ? PlayerRPGExtra : PlayerRPG);
	commandToClient(%client, 'PlayGui_CreateToolHud', %client.player.dataBlock.maxTools);
}

package RPG_rewards
{
   function Armor::onDisabled(%db,%this,%state)
   {
      if(%this.lastAttacker.client.RPG["level"] && RPG_MinigameCheck(%this.lastAttacker.client))
      {
         %loot = $MonsterData::Loot[%this.dataBlock.uiName];
         %exp = $MonsterData::Exp[%this.dataBlock.uiName];
		 if(%loot !$= "" || %exp !$= "")
		 {
			if(%loot $= "" || %loot < 0)
				%loot = 0;
			if(%exp $= "" || %exp < 0)
				%exp = 0;
			%this.lastAttacker.client.RPG["gold"] += %loot;
			addExp(%this.lastAttacker.client, %exp);
			messageClient(%this.lastAttacker.client, '', "\c2" @ %this.dataBlock.uiName @ "\c3:" SPC "You get\c2" SPC %exp SPC "\c3exp and\c2" SPC %loot SPC "\c3gold");
		}
      }
      Parent::onDisabled(%db,%this,%state);
   }
};activatepackage(RPG_rewards);

function addExp(%client, %amount)
{
	%client.RPG["exp"] += %amount;

	%exp = %client.RPG["exp"];
	%level = %client.RPG["level"];

	if (%exp >= $RPG::ExpTable[%level + 1])
	{
		%client.player.playSound(rewardSound);

		%client.centerPrint("\c6Level up!",3);
		%client.schedule(3000, centerPrint, "\c3You get 1 SP",3);
		%client.RPG["level"]++;
		%client.RPG["sp"]++;

		updateHP(%client);
		updateMaxMP(%client);
		updateMaxHP(%client);
		updateArrows(%client);
		%client.player.setEnergyLevel(%client.RPG["mp"] / %client.RPG["maxmp"] * 100);
	}
	//%client.displayInfo();
}

function ServerCmdAdd(%client, %stat, %value)
{
	if(!RPG_Minigamecheck(%client, 1))
		return;
	
	switch$(%stat)
	{
		case "str":
			addStr(%client, %value);
		case "dex":
			addDex(%client, %value);
		case "con":
			addCon(%client, %value);
		case "int":
			addInt(%client, %value);
		default:
			messageClient(%client, '', "\c3The syntax is /add [stat] [amount]");
			messageClient(%client, '', "\c3Strength: /add str");
			messageClient(%client, '', "\c3Dexterity: /add dex");
			messageClient(%client, '', "\c3Constitution: /add con");
			messageClient(%client, '', "\c3Intelligence: /add int");
	}
}

function addStr(%client, %amount)
{
	if (%amount $= "") %amount = 1;

	if (%client.RPG["sp"] < %amount)
	{
		%client.centerPrint("Insufficient skill points",3);
		return;
	}
	%client.RPG["sp"] -= %amount;
	%client.RPG["str"] += %amount;

	%client.centerPrint("\c6Strength raised!",3);
	serverCmdStats(%client);

	//%client.displayInfo();
}

function addDex(%client, %amount)
{
	if (%amount $= "") %amount = 1;

	if (%client.RPG["sp"] < %amount)
	{
		%client.centerPrint("Insufficient skill points",3);
		return;
	}
	%client.RPG["sp"] -= %amount;
	%client.RPG["dex"] += %amount;

	%client.centerPrint("\c6Dexterity raised!",3);
	serverCmdStats(%client);

	//%client.displayInfo();
}

function addCon(%client, %amount)
{
	if (%amount $= "") %amount = 1;

	if (%client.RPG["sp"] < %amount)
	{
		%client.centerPrint("Insufficient skill points",3);
		return;
	}
	%client.RPG["sp"] -= %amount;
	%client.RPG["con"] += %amount;

	%client.centerPrint("\c6Constitution raised!",3);

	updateMaxHP(%client);
	updateHP(%client);
	serverCmdStats(%client);
	//%client.displayInfo();
}

function addInt(%client, %amount)
{
	if (%amount $= "") %amount = 1;

	if (%client.RPG["sp"] < %amount)
	{
		%client.centerPrint("Insufficient skill points",3);
		return;
	}
	%client.RPG["sp"] -= %amount;
	%client.RPG["int"] += %amount;

	%client.centerPrint("\c6Intelligence raised!",3);

	updateMaxMP(%client);
	serverCmdStats(%client);
	%client.player.setEnergyLevel(%client.RPG["mp"] / %client.RPG["maxmp"] * 100);
	//%client.displayInfo();
}

function ProjectileData::damage(%this,%obj,%col,%fade,%pos,%normal)
{
	if(%this.image $= "")
	{
		echo("WARNING: Could not determine weapon image:");
		echo(%this);
	}

	%base = getBaseAttackDirect(%this, %this.image, %obj.sourceObject);
	if(%base <= 0)
		return;
	%stat = getStat(%this.image);
	%pow = getPow(%obj.client, %stat);
	%def = getDef(%col, %stat);
	%atk = calculateAttackDirect(%base, %pow, %this);
	%directDamage = calculateDamageDirect(%atk, %def);	
	
   %damageType = $DamageType::Direct;
   if(%this.DirectDamageType)
      %damageType = %this.DirectDamageType;

   %scale = getWord(%obj.getScale(), 2);
   //%directDamage = mClampF(%this.directDamage, -100, 100) * %scale;
	%directDamage *= %scale;

   if(%col.getType() & $TypeMasks::PlayerObjectType)
   {
      %col.damage(%obj, %pos, %directDamage, %damageType);
   }
   else
   {
      %col.damage(%obj, %pos, %directDamage, %damageType);
   }	
}

function ProjectileData::radiusDamage(%this, %obj, %col, %distanceFactor, %pos, %damageAmt)
{
	if(%this.image $= "")
	{
		echo("WARNING: Could not determine weapon image:");
		echo(%this.uiName);
	}

   //validate distance factor
   if(%distanceFactor <= 0)
      return;
   else if(%distanceFactor > 1)
      %distanceFactor = 1;
	  
	%base = getBaseAttackRadius(%this, %this.image);
	if(%base <= 0)
		return;
	%stat = getStat(%this.image);
	%pow = getPow(%obj.client, %stat);
	%def = getDef(%col, %stat);
	%atk = calculateAttackRadius(%base, %pow) * %distanceFactor * getWord(%obj.getScale(), 2);
	%damageAmt = calculateDamageRadius(%atk, %def);

   if(%damageAmt)
   {
      //use default damage type if no damage type is given
      %damageType = $DamageType::Radius;
      if(%this.RadiusDamageType)
         %damageType = %this.RadiusDamageType;

      %col.damage(%obj, %pos, %damageAmt, %damageType);

      //burn the player?
      if(%this.explosion.playerBurnTime > 0)
      {
         if(%col.getType() & ($TypeMasks::PlayerObjectType | $TypeMasks::CorpseObjectType))
         {
            //check for vehicle protection from burning
            %doBurn = true;
            if(%col.isMounted())
            {
               %mountData = %col.getObjectMount().getDataBlock();
               if(%mountData.protectPassengersBurn)
                  %doBurn = false;
            }

            if(%doBurn)
               %col.burn(%this.explosion.playerBurnTime * %distanceFactor);
         }  
      }
   }
}

function getBaseAttackDirect(%proj, %image, %player)
{
	if(%player.client.RPG["level"] || $MonsterData::Attack[%player.dataBlock.uiName] $= "")
		if($ItemData::Attack[%image.item.uiName] !$= "")
			return $ItemData::Attack[%image.item.uiName];
		else
			return %proj.directDamage;
	else
		return $MonsterData::Attack[%player.dataBlock.uiName];
}

function getBaseAttackRadius(%proj, %image)
{
	if($ItemData::RadiusAttack[%image.item.uiName] !$= "")
		return $ItemData::RadiusAttack[%image.item.uiName];
	else
		return %proj.explosion.radiusDamage;
}

function getStat(%image)
{
	switch$ ($ItemData::Type[%image.item.uiName])
	{
		case "Sword":
			%stat = "Str";
		case "Throw":
			%stat = "Str";
		case "Bow":
			%stat = "Dex";
		case "Magic":
			%stat = "Int";
		default:
			//echo("Weapon type not specified");
			%stat = "Str";
	}
	return %stat;
}

function getPow(%client, %stat)
{
	%pow = %client.RPG[%stat];
	if(%pow <= 0)
		%pow = 1;
	return %pow;
}

function calculateAttackDirect(%base, %pow, %proj)
{
	if($ItemData::RadiusAttack[%proj.image.item.uiName] $= "")
	{
		if(%proj.explosion.radiusdamage <= 0 || %proj.explosion.damageRadius <= 0)
			%atk = mFloor(%base + %base * (%pow - 1) / 10 + (%pow - 1));
		else
			%atk = mFloor(%base + %base * (%pow - 1) / 10);
	}
	else
		%atk = mFloor(%base + %base * (%pow - 1) / 10);
	return %atk;
}

function calculateAttackRadius(%base, %pow)
{
	return mFloor(%base + %base * (%pow - 1) / 10 + (%pow - 1));
}

function getDef(%player, %stat)
{
	if(%player.client.RPG["level"])
	{
		if(%stat $= "int")
			%def = %player.client.RPG["mdef"];
		else
			%def = %player.client.RPG["def"];
	}
	else
	{
		if(%stat $= "int")
			%def = $MonsterData::MagicDefense[%player.dataBlock.uiName];
		else
			%def = $MonsterData::Defense[%player.dataBlock.uiName];
	}
	if(%def <= 0)
		%def = 0;
	return %def;
}

function calculateDamageDirect(%atk, %def)
{
	%dmg = %atk - %def;
	if(%dmg <= 0)
		%dmg = 1;
	return %dmg;
}

function calculateDamageRadius(%atk, %def)
{
	%dmg = %atk - %def;
	if(%dmg < 0)
		%dmg = 0;
	return %dmg;
}