
$BRPG_respawnTime = 9;

package RPG_RespawnDelay
{
	function GameConnection::spawnPlayer(%client)
	{
		if(%client.isRespawning)
		{
			%client.isRespawning = false;
			Parent::spawnPlayer(%client);
		}
		else
		{
			%client.isRespawning = true;
			%client.schedule(1000, spawnPlayer);
		}
	}
};activatepackage(RPG_RespawnDelay);

package RPG_BottomPrint
{
	function GameConnection::BottomPrint(%client, %str, %time)
	{
		if(!%client.RPG_PrintingHud)
			%client.RPG_BottomPrint = %client.schedule(%time * 1000, BottomPrintClear);
		Parent::BottomPrint(%client, %str, %time);
	}
};activatepackage(RPG_BottomPrint);

function GameConnection::BottomPrintClear(%client)
{
	%client.RPG_BottomPrint = "";
}

function RPG_Minigamecheck(%client, %mode)
{
	if(%client.minigame > 0 || $RPG_NoMiniGame)
		return true;
	else
	{
		if(%mode == 1)
			messageClient(%client, '', "\c3Minigame is required");
		return false;
	}
}

package checkpointfix
{
	function serverCmdClearCheckpoint(%client)
	{
		if(isObject(%client.checkPointBrick))
			%client.RPG_skipCheckpointLoading = true;
		Parent::serverCmdClearCheckpoint(%client);
	}
};activatepackage(checkpointfix);

function GameConnection::RPGPlayerLoop(%client)
{
	if(RPG_MinigameCheck(%client))
	{
		updateHP(%client);
		updateMP(%client);
		if(!%client.RPG_BottomPrint)
		{
			%client.RPG_PrintingHud = true;
			%client.displayHud();
			%client.RPG_PrintingHud = false;
		}
		%client.saveStats();
		checkRegion(%client);
		cancel(%client.RPGPlayerLoop);
		%client.RPGPlayerLoop = %client.schedule(1000, RPGPlayerLoop);
	}
}

function GameConnection::displayHud(%client)
{
	%hud = "<font:verdana:16>";
	%hud = %hud SPC "\c3Exp:" SPC "\c6" @ %client.RPG["exp"];
	if(%client.RPG["level"] < 20)
		%hud = %hud @ "/" @ $RPG::ExpTable[%client.RPG["level"] + 1];
	%hud = %hud SPC "\c3Gold:" SPC "\c6" @ %client.RPG["gold"];
	%hud = %hud SPC "\c3Class:" SPC "\c6" @ %client.RPG["class"];
	%hud = %hud SPC "\c3Level:" SPC "\c6" @ %client.RPG["level"];
	%hud = %hud SPC "\c3HP:" SPC "\c6" @ %client.RPG["hp"] @ "/" @ %client.RPG["maxhp"];
	%hud = %hud SPC "\c3MP:" SPC "\c6" @ %client.RPG["mp"] @ "/" @ %client.RPG["maxmp"];
	if(%client.RPG["pvp"])
		%hud = %hud SPC "\c3PvP:" SPC "\c6ON";
	else
		%hud = %hud SPC "\c3PvP:" SPC "\c6OFF";
	//if(%client.RPG["guild"] !$= "")
	//{
	//	%hud = %hud NL " \c3Guild:" SPC "\c6" @ %client.RPG["guild"];
	//	%hud = %hud SPC "\c3Rank:" SPC "\c6" @ $RPG::string["rank_" @ %client.RPG["rank"]];
	//}
	%client.bottomPrint(%hud , 2);
}

function serverCmdChar(%client, %char)
{
	if(!RPG_Minigamecheck(%client, 1))
		return;
	
	if(%client.player)
	{
		if($uinametable_items["Hammer "] == 0)
		{
			echo("WARNING: uiNameTable not set!");
			return;
		}
		
		%char = atoi(%char);
		if(%char <= 0) %char = 1;
		
		if(%char == %client.RPG["char"])
		{
			messageClient(%client, '', "\c3You are already using that character!");
			return;
		}
		
		%client.RPG["char"] = charCheck(%client, %char);
		
		%temp = %client.RPG["pvp"];
		%charsFound = %client.loadStats();
		if(%charsFound < %client.RPG["char"])
		{
			messageClient(%client, '', "\c3Character" SPC "\c2" @ %client.RPG["char"] SPC "\c3not found, creating new");
			%client.RPG["char"] = %charsFound + 1;
			messageClient(%client, '', "\c3You changed to character \c2" @ %client.RPG["char"]);
			setDefaultValues(%client);
			%client.checkpointbrick = "";
			%client.player.instantRespawn();
		}
		else
		{
			messageClient(%client, '', "\c3You changed to character \c2" @ %client.RPG["char"]);
			%client.player.instantRespawn();
		}
		if(!%temp && %client.RPG["pvp"])
		{
			messageAll("", "\c2" @ %client.name SPC "\c5is now in PvP");
			messageClient(%client, '', "\c3PvP mode is now \c0ON.");
			messageClient(%client, '', "\c3You may hurt other players who are also in PvP mode.");
			messageClient(%client, '', "\c3Say \c2/leavePvP \c3to leave the PvP.");
		}
		if(%temp && !%client.RPG["pvp"])
		{
			messageAll("", "\c2" @ %client.name SPC "\c5is no longer in PvP");
			messageClient(%client, '', "\c3PvP mode is now \c2OFF.");
			messageClient(%client, '', "\c3You may no longer hurt or be hurt by other players.");
		}
	}
}

function charCheck(%client, %char)
{
	while(1)
	{
		for(%i = 0; %i < ClientGroup.getCount(); %i++)
		{
			%target = ClientGroup.getObject(%i);
			if(%target.bl_ID == %client.bl_ID && %target.RPG["char"] == %char && %target != %client)
			{
				messageClient(%client,'',"WARNING:" SPC "\c3Character" SPC "\c2" @ %char SPC "\c3in use, switching to character\c2" SPC %char + 1);
				%char++;
				%i = -1;
			}
		}
		return %char;
	}
}

function serverCmdHelp(%client)
{
	if(!RPG_Minigamecheck(%client, 1))
		return;
	
	messageClient(%client,'',"\c2BasicRPG commands");
	messageClient(%client,'',"\c3/stats");
	messageClient(%client,'',"\c3/add");
	messageClient(%client,'',"\c3/char");
	messageClient(%client,'',"\c3/quest");
	messageClient(%client,'',"\c3/pvp");
	messageClient(%client,'',"\c3/givegold");
	messageClient(%client,'',"\c3/removearmor");
	messageClient(%client,'',"\c3/removepack");
	messageClient(%client,'',"\c3/help");
	messageClient(%client,'',"\c5Use PageUp/PageDown to see all commands");
}

function serverCmdStats(%client)
{
	if(!RPG_Minigamecheck(%client, 1))
		return;
	
	%image = %client.player.tool[%client.player.lastUsedTool].image;
	%baseDirect = getBaseAttackDirect(%image.projectile, %image, %client.player);
	%baseRadius = getBaseAttackRadius(%image.projectile, %image);
	%stat = getStat(%image);
	%pow = getPow(%client, %stat);
	if(%baseDirect > 0)
		%atkDirect = calculateAttackDirect(%baseDirect, %pow, %image.projectile);
	if(%baseRadius > 0)
		%atkRadius = calculateAttackRadius(%baseRadius, %pow);
	%atk = %atkDirect + %atkRadius;
	
	messageClient(%client, '', "\c3Name:" SPC %client.RPG["name"] SPC "\c3Class:" SPC %client.RPG["class"]);
	messageClient(%client, '', "\c3Level:" SPC %client.RPG["level"] SPC "\c3Gold:" SPC %client.RPG["gold"] SPC "\c3Exp:" SPC %client.RPG["exp"] SPC "\c3SP:" SPC %client.RPG["sp"]);
	messageClient(%client, '', "\c3HP:" SPC %client.RPG["hp"] SPC "/" SPC %client.RPG["maxhp"]);
	messageClient(%client, '', "\c3MP:" SPC %client.RPG["mp"] SPC "/" SPC %client.RPG["maxmp"]);
	messageClient(%client, '', "\c3Strength:" SPC %client.RPG["str"] SPC "\c3Dexterity:" SPC %client.RPG["dex"] SPC "\c3Constitution:" SPC %client.RPG["con"] SPC "\c3Intelligence:" SPC %client.RPG["int"]);
	messageClient(%client, '', "\c3Attack:" SPC %atk SPC "\c3Defense:" SPC %client.RPG["def"]);
}

$RPG::string["quest_1-1"] = "Get equipped";
$RPG::string["quest_1-2"] = "Learn the basics";
$RPG::string["quest_1-3"] = "Gain a level";

function serverCmdQuest(%client, %str)
{
	if(!RPG_Minigamecheck(%client, 1))
		return;
	
	switch$(%str)
	{
		case "list":
			messageClient(%client, '', "\c2Quests (Hills)");
			for(%i = 1; %i <= 3; %i++)
			{
				switch(%client.RPG["quest_1-" @ %i])
				{
					case 0:
						messageClient(%client, '', "\c3" @ %i @ ":\c6"  SPC "Not started");
					case 1:
						messageClient(%client, '', "\c3" @ %i @ ":\c6" SPC $RPG::string["quest_1-" @ %i] SPC "-" SPC "\c2Completed");
					default:
						messageClient(%client, '', "\c3" @ %i @ ":\c6" SPC $RPG::string["quest_1-" @ %i] SPC "-" SPC "\c3In progress");
				}
			}
		default:
			if(atoi(%str) > 0)
			{
				messageClient(%client, '', "\c2Quest details:");
				messageClient(%client, '', "\c3Not yet available!");
			}
			else
			{
				messageClient(%client, '', "\c2Quest commands:");
				messageClient(%client, '', "\c3/quest list");
				messageClient(%client, '', "\c3/quest # (quest number)");
			}
	}
	

}
function GameConnection::questCompleted(%client, %str)
{
	%client.playSound(rewardSound);
	%client.centerPrint("\c2Quest Completed!",3);
	messageClient(%client, '', "\c2Quest completed:");
	messageClient(%client, '', "\c3" @ $RPG::string[%str]);
}

function GameConnection::questStarted(%client, %str)
{
	messageClient(%client, '', "\c2Quest started:");
	messageClient(%client, '', "\c3" @ $RPG::string[%str]);
}

 function serverCmdPvP(%client, %str)
{
	if(!RPG_Minigamecheck(%client, 1))
		return;
	
	switch$(%str)
	{
		case "on":
			enterPVP(%client);
		case "off":
			leavePVP(%client);
		default:
			if(%client.RPG["pvp"] == 1)
				messageClient(%client, '', "\c3PvP mode is currently \c0ON");
			else
				messageClient(%client, '', "\c3PvP mode is currently \c2OFF");
			messageClient(%client, '', "\c2PvP commands:");
			messageClient(%client, '', "\c3/pvp on");
			messageClient(%client, '', "\c3/pvp off");
			messageClient(%client, '', "\c3/pvp list");
	}
}

function enterPVP(%client)
{
	if(!RPG_Minigamecheck(%client, 1))
		return;
		
	if(%client.RPG["pvp"] == 0)
	{
		//if(%client.RPG["guild"] $= "")
			messageAll("", "\c2" @ %client.name SPC "\c5is now in PvP");
		//else
		//	messageAll("", "\c2" @ %client.name SPC "\c5has re-entered the guild.");
		messageClient(%client, '', "\c3PvP mode is now \c0ON.");
		messageClient(%client, '', "\c3You may hurt other players who are also in PvP mode.");
		messageClient(%client, '', "\c3Say \c2/pvp off \c3to leave the PvP.");
		%client.RPG["pvp"] = 1;
		//if(%client.RPG["guild"] $= "")
			%client.player.setShapeNameColor("0.09 0.09 0.09 1");
		//else
		//{
		//	%color = $GuildData::Color[%client.RPG["guild"]];
		//	%client.player.setShapeNameColor(getColorIDTable(%color));
		//}
	}
	else
	{
		messageClient(%client, '', "\c3You are already in PvP");
		messageClient(%client, '', "\c3Say \c2/pvp off \c3to leave the PvP.");
	}
}

function leavePvP(%client)
{
	if(!RPG_Minigamecheck(%client, 1))
		return;
		
	if(%client.RPG["pvp"] == 1)
	{
		//if(%client.RPG["guild"] $= "")
			messageAll("", "\c2" @ %client.name SPC "\c5is no longer in PvP");
		//else
		//	messageAll("", "\c2" @ %client.name SPC "\c5has temporarily left the guild.");
		messageClient(%client, '', "\c3PvP mode is now \c2OFF.");
		messageClient(%client, '', "\c3You may no longer hurt or be hurt by other players.");
		%client.RPG["pvp"] = 0;
		%client.player.setShapeNameColor("1 1 1 1");
	}
	else
	{
		messageClient(%client, '', "\c3You are already outside of PvP");
	}
}

 function listPvP(%client)
{
	if(!RPG_Minigamecheck(%client, 1))
		return;
		
	messageClient(%client, '', "\c2These are the players in PvP:");
	messageClient(%client, '', "\c3Function not done yet. Whine to Jorgur about it.");
}

function serverCmdGiveGold(%client, %text, %number)
{
	if(!RPG_Minigamecheck(%client, 1))
		return;
	
	if(atoi(%text) || atoi(%number) <= 0 != 0 || %text $= "")
	{
		messageClient(%client, '', "\c3The syntax is /givegold [player] [amount]");
		return;
	}
	%target = findClientByName(%text);
	if(!%target)
	{
		messageClient(%client, '', "\c3Client" SPC "'" @ %text @ "'" SPC "not found!");
		return;
	}
	if(%client.RPG["gold"] < %number)
	{
		messageClient(%client, '', "\c3Not enough gold!");
		return;
	}
	%client.RPG["gold"] -= %number;
	%target.RPG["gold"] += %number;
	messageClient(%client, '', "\c3You gave" SPC %number SPC "gold to" SPC %target.name);
	messageClient(%target, '', "\c3" @ %client.name SPC "gave you" SPC %number SPC "gold");
}

function serverCmdSetClass(%client, %target, %class)
{
	if(!RPG_Minigamecheck(%client, 1))
		return;
	
	if(!%client.isSuperAdmin)
		return;
	echo("client:" SPC %client);
	echo("target:" SPC %target);
	echo("class:" SPC %class);
	findClientByName(%target).RPG["class"] = %class;
}

function serverCmdUpdateRPG(%client)
{
	if(!%client.isSuperAdmin)
		return;
	exec("Add-Ons/system_BRPG/monsters.cs");
	exec("Add-Ons/system_BRPG/weapons.cs");
	exec("Add-Ons/RP_shop/server.cs");
	messageAll("", "\c5The RPG has been updated.");
}

function serverCmdBRPG(%client, %text)
{
	if(!%client.isSuperAdmin)
		return;
	exec("add-ons/system_BasicRPG/" @ %text @ ".cs");
}
